<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="$lang$" xml:lang="$lang$"$if(dir)$ dir="$dir$"$endif$>
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
$for(author-meta)$
  <meta name="author" content="$author-meta$" />
$endfor$
$if(date-meta)$
  <meta name="dcterms.date" content="$date-meta$" />
$endif$
$if(keywords)$
  <meta name="keywords" content="$for(keywords)$$keywords$$sep$, $endfor$" />
$endif$
$if(description-meta)$
  <meta name="description" content="$description-meta$" />
$endif$
  <title>$pagetitle$</title>

  <!-- Third-party components -->
  <!-- Terminal (xtermjs) -->
  <script src="$lbdir$/assets/external/xterm-5.5.0.min.js"></script>
  <script src="$lbdir$/assets/external/xterm-addon-fit-0.10.0.min.js"></script>
  <link rel="stylesheet" href="$lbdir$/assets/external/xterm-5.5.0.min.css"/>
  <!-- Code editor (CodeMirror) -->
  <script src="$lbdir$/assets/external/codemirror-5.65.18.min.js"></script>
  <link rel="stylesheet" href="$lbdir$/assets/external/codemirror-5.65.18.min.css"/>
  <!-- UI toolkit (Bootstrap) -->
  <script src="$lbdir$/assets/external/bootstrap-5.3.3.bundle.min.js"></script>
  <link rel="stylesheet" href="$lbdir$/assets/external/bootstrap-5.3.3.min.css"/>
  <link rel="stylesheet" href="$lbdir$/assets/external/bootstrap-icons-1.11.3.min.css"/>

  <!-- LupBook components -->

  <!-- VM -->
  <script src="$lbvm$"></script>

  <!-- Activities -->
  <script src="$lbdir$/assets/internal/save.js"></script>
  <script src="$lbdir$/assets/internal/lupbook.js"></script>
  <script src="$lbdir$/assets/internal/toc.js"></script>
  <script src="$lbdir$/assets/internal/fib.js"></script>
  <script src="$lbdir$/assets/internal/icode.js"></script>
  <script src="$lbdir$/assets/internal/matching.js"></script>
  <script src="$lbdir$/assets/internal/mcq.js"></script>
  <script src="$lbdir$/assets/internal/parsons.js"></script>
  <script src="$lbdir$/assets/internal/hparsons.js"></script>
  <script src="$lbdir$/assets/internal/theme.js"></script>

  <link rel="stylesheet" href="$lbdir$/assets/internal/lupbook.css"/>
  <link rel="stylesheet" href="$lbdir$/assets/internal/fib.css"/>
  <link rel="stylesheet" href="$lbdir$/assets/internal/icode.css"/>
  <link rel="stylesheet" href="$lbdir$/assets/internal/matching.css"/>
  <link rel="stylesheet" href="$lbdir$/assets/internal/mcq.css"/>
  <link rel="stylesheet" href="$lbdir$/assets/internal/parsons.css"/>

  <!-- Custom components -->
  <!-- Custom CSS-->
  <style>
/* Code styling */
code {
    background-color: var(--bs-tertiary-bg);
    padding: 0.1em 0.2em;
    border: var(--bs-border-style) var(--bs-border-width) var(--bs-border-color);
    border-radius: var(--bs-border-radius);
}

.CodeMirror {
  font-size: smaller; /* Make code slightly smaller than the text */
}

/* Add some space to top of page when clicking on an anchor to reach a header,
 * otherwise the header ends up being hidden behind our sticky top navbar */
main section {
  scroll-margin-top: 5rem;
}

main h2 {
  margin-top: 3rem;
}
main > section > h1:first-of-type {
  margin-top: 0rem;
}

/* Link styling in page TOC */
.lb-toc a.active {
  font-weight: 600;
}
.lb-toc a.active,
.lb-toc a:hover {
  background-color: var(--bs-secondary-bg) !important;
}

/* Only when page width is more than bootstrap's `md` breakpoint */
@media (min-width: 768px) {
    /* Make page TOC be sticky and scrollable */
    #lb-page-toc-aside {
        position: sticky;
        top: 4rem;
        height: calc(100vh);
        overflow-y: auto;
    }
}
  </style>
$for(header-includes)$
  $header-includes$
$endfor$
$if(math)$
  $math$
$endif$
</head>
<body>
  <!-- Custom includes -->
$for(include-before)$
$include-before$
$endfor$
  <!-- Sticky top bar for navigation and options -->
  <nav class="navbar sticky-top bg-body-secondary py-1 flex-nowrap">
    <div class="container-fluid">
      <!-- Main TOC -->
      <button class="navbar-toggler border-0 shadow-none" type="button" data-bs-toggle="offcanvas" data-bs-target="#lb-main-toc-offcanvas">
        <i class="bi bi-list"></i>
      </button>
      <div class="offcanvas offcanvas-start" tabindex="-1" id="lb-main-toc-offcanvas">
        <div class="offcanvas-header align-items-baseline bg-body-secondary">
          <div class="d-flex flex-column">
            <h5 class="offcanvas-title" id="lb-name"><a class="text-decoration-none text-reset" href="#">$pagetitle$</a>$if(subtitle)$<br><small class="text-body-secondary">$subtitle$</small>$endif$</h5>
            $for(author)$
            <small class="fst-italic fw-light">$author$</small>
            $endfor$
            $if(date)$
            <small class="fw-light">$date$</small>
            $endif$
          </div>
          <button type="button" class="btn-close" data-bs-dismiss="offcanvas"></button>
        </div>
        <div class="offcanvas-body text-body-secondary lb-toc">
$main-toc$
        </div>
      </div>
      <!-- Section title -->
      <span id="lb-page-title" class="fs-5 text-truncate">$pagetitle$</span>
      <div class="d-flex align-items-center">
        <!-- Status Indicator -->
        <div id="lb-saving-indicator" class="position-relative" data-bs-toggle="tooltip" data-bs-placement="bottom" title="Loading">
          <!-- Spinner (loading state) -->
          <i class="spinner-border spinner-border-sm" id="lb-saving-loading"></i>
          <!-- Checkmark (success state) -->
          <i class="bi bi-check-circle text-body d-none" id="lb-saving-success"></i>
          <!-- Error (error state) -->
          <i class="bi bi-exclamation-circle text-danger d-none" id="lb-saving-error"></i>
          <!-- Red Dot Badge -->
          <span class="position-absolute top-0 start-100 translate-middle p-1 bg-warning-subtle border border-light rounded-circle" id="lb-saving-badge"></span>
        </div>
        <!-- Configuration -->
        <button class="navbar-toggler border-0 shadow-none" type="button" data-bs-toggle="offcanvas" data-bs-target="#lb-config-offcanvas">
          <i class="bi bi-three-dots-vertical"></i>
        </button>
        <div class="offcanvas offcanvas-end" tabindex="-2" id="lb-config-offcanvas">
          <div class="offcanvas-header bg-body-secondary">
            <h5 class="offcanvas-title">Actions</h5>
            <button type="button" class="btn-close" data-bs-dismiss="offcanvas"></button>
          </div>
          <div class="offcanvas-body p-4 pt-0">
            <ul class="navbar-nav justify-content-end flex-grow-1 pe-3">
              <li class="nav-item">
                <button class="btn btn-link nav-link" type="button" data-bs-toggle="modal" data-bs-target="#lbvm-terminal-modal">
                  <i class="bi bi-terminal"></i>
                  <span class="ms-2">Show terminal</span>
                </button>
              </li>
              <li class="nav-item">
                <button class="btn btn-link nav-link" type="button" data-bs-toggle="collapse" data-bs-target="#lb-theme-options" aria-expanded="false" aria-controls="lb-theme-options">
                  <i class="bi bi-palette"></i>
                  <span class="ms-2">Change theme</span>
                </button>
                <div class="collapse" id="lb-theme-options">
                  <ul class="navbar-nav justify-content-end flex-grow-1 pe-3 ps-4">
                    <li class="nav-item">
                      <button class="btn btn-link nav-link" type="button" id="lb-theme-auto">
                        <i class="bi bi-gear"></i>
                        <span class="ms-2">System default</span>
                        <i class="bi bi-check ms-2 d-none" id="lb-theme-auto-check"></i>
                      </button>
                    </li>
                    <li class="nav-item">
                      <button class="btn btn-link nav-link" type="button" id="lb-theme-light">
                        <i class="bi bi-sun"></i>
                        <span class="ms-2">Light mode</span>
                        <i class="bi bi-check ms-2 d-none" id="lb-theme-light-check"></i>
                      </button>
                    </li>
                    <li class="nav-item">
                      <button class="btn btn-link nav-link" type="button" id="lb-theme-dark">
                        <i class="bi bi-moon"></i>
                        <span class="ms-2">Dark mode</span>
                        <i class="bi bi-check ms-2 d-none" id="lb-theme-dark-check"></i>
                      </button>
                    </li>
                  </ul>
                </div>
              </li>
              <!-- Import/export -->
              <li class="nav-item">
                <label class="btn btn-link nav-link text-start" for="import-data-input">
                  <i class="bi bi-file-earmark-arrow-down"></i>
                  <span class="ms-2">Import data</span>
                  <input id="import-data-input" class="d-none" type="file" accept=".json" />
                </label>
              </li>
              <li class="nav-item">
                <button id="export-data-button" class="btn btn-link nav-link" type="button">
                  <i class="bi bi-file-earmark-arrow-up"></i>
                  <span class="ms-2">Export data</span>
                </button>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </nav>
  <!-- Terminal modal -->
  <div class="modal fade" id="lbvm-terminal-modal" tabindex="-1" aria-labelledby="lbvm-terminal-label" aria-hidden="true">
    <div class="modal-dialog modal-fullscreen">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">LupBookVM Terminal</h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body lbvm-terminal-container">
          <div id="lbvm-terminal" class="w-100 h-100"></div>
        </div>
      </div>
    </div>
  </div>
  <!-- Page content -->
  <div class="container-xxl mt-3">
    <div class="row">
      <aside id="lb-page-toc-aside" class="col-md-2 d-none d-md-block text-body-secondary lb-toc">
        <strong class="h6 my-2 ms-3">Outline</strong>
        <hr class="my-2 ms-3">
$page-toc$
      </aside>

      <main id="lb-page-body" data-bs-spy="scroll" data-bs-smooth-scroll="true" data-bs-target="#lb-page-toc-aside" class="col-md-10">
        <section id="lb-root-section" class="level0 d-none">
$body$
        </section>
      </main>
    </div>
  </div>
  <!-- Footer -->
  <footer>
    <div class="d-flex flex-column bg-body-secondary p-2">
      <div class="px-2 fw-bold">$pagetitle$</div>
      $if(subtitle)$
      <div class="px-2 fw-light">$subtitle$</div>
      $endif$
      $for(author)$
      <small class="px-2 fw-light fst-italic">$author$</small>
      $endfor$
      $if(date)$
      <small class="px-2 fw-light">$date$</small>
      $endif$
    </div>
  </footer>
$for(include-after)$
$include-after$
$endfor$
</body>
</html>
